unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Menus, Grids, Db, DBTables, MDBGrid, ExtCtrls, DBGrids;

type
  TForm1 = class(TForm)
    DataSource1: TDataSource;
    Table1: TTable;
    dbg: TMDBGrid;
    Table1SpeciesNo: TFloatField;
    Table1Category: TStringField;
    Table1Common_Name: TStringField;
    Table1SpeciesName: TStringField;
    Table1Lengthcm: TFloatField;
    Table1Length_In: TFloatField;
    Table1Notes: TMemoField;
    Table1Graphic: TGraphicField;
    procedure DataSource1DataChange(Sender: TObject; Field: TField);
    procedure dbgTitleBtnClick(Sender: TObject; ACol: Integer;
      Column: TDBGColumn);
  private
  public
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}


procedure TForm1.DataSource1DataChange(Sender: TObject; Field: TField);
begin
  dbg.Columns[0].Footer.Text:=Format('Record Count: %d',[Table1.RecordCount]);
end;

procedure TForm1.dbgTitleBtnClick(Sender: TObject; ACol: Integer;
  Column: TDBGColumn);
begin
  try
    Column.Title.SortMarker:=TSortMarker(Integer(Column.Title.SortMarker)+1);
    if Column.Title.SortMarker>High(TSortMarker) then
      Column.Title.SortMarker:=TSortMarker(0);
  except
    Column.Title.SortMarker:=TSortMarker(0);
  end;
end;

end.
