{$DEFINE J_DELPHI}  
{$DEFINE J_VCL30_OR_GREATER}
{$DEFINE J_VCL35_OR_GREATER}
{$DEFINE J_VCL40_OR_GREATER}
{$DEFINE J_VCL50_OR_GREATER}
{$DEFINE J_VCL60_OR_GREATER}

{$IFDEF VER140}    // Delphi v6
{$IFNDEF BCB}
{$DEFINE J_DELPHI_6}
{$DEFINE J_VCL60}
{$DEFINE J_SUPPORTED_COMPILER}
{$ENDIF}
{$ENDIF}

{$IFDEF VER130}    // Delphi v5
{$UNDEF J_VCL60_OR_GREATER}
{$IFNDEF BCB}
{$DEFINE J_DELPHI_5}
{$DEFINE J_VCL50}
{$DEFINE J_SUPPORTED_COMPILER}
{$ELSE}
    // C++Builder v5
{$UNDEF J_DELPHI}
{$DEFINE J_CPPB}
{$DEFINE J_CPPB_5}
{$DEFINE J_VCL50} // same VCL version as Delphi 5
{$DEFINE J_SUPPORTED_COMPILER}
{$ENDIF}
{$ENDIF}

{$IFDEF VER125}    // C++Builder v4
{$UNDEF J_DELPHI}
{$DEFINE J_CPPB}
{$DEFINE J_CPPB_4}
{$UNDEF J_VCL50_OR_GREATER}
{$UNDEF J_VCL60_OR_GREATER}
{$DEFINE J_VCL40} // same VCL version as Delphi 4
{$DEFINE J_SUPPORTED_COMPILER}
{$ENDIF}

{$IFDEF VER120}    // Delphi v4
{$DEFINE J_DELPHI_4}
{$UNDEF J_VCL50_OR_GREATER}
{$UNDEF J_VCL60_OR_GREATER}
{$DEFINE J_VCL40}
{$DEFINE J_SUPPORTED_COMPILER}
{$ENDIF}

{$IFDEF VER110}    // C++Builder v3
{$UNDEF J_DELPHI}
{$DEFINE J_CPPB}
{$DEFINE J_CPPB_3}
{$UNDEF J_VCL40_OR_GREATER}
{$UNDEF J_VCL50_OR_GREATER}
{$UNDEF J_VCL60_OR_GREATER}
{$DEFINE J_VCL35}
{$DEFINE J_SUPPORTED_COMPILER}
{$ENDIF}

{$IFDEF VER100}    // Delphi v3
{$DEFINE J_DELPHI_3}
{$UNDEF J_VCL35_OR_GREATER}
{$UNDEF J_VCL40_OR_GREATER}
{$UNDEF J_VCL50_OR_GREATER}
{$UNDEF J_VCL60_OR_GREATER}
{$DEFINE J_VCL30}
{$DEFINE J_SUPPORTED_COMPILER}
{$ENDIF}

{$IFNDEF J_SUPPORTED_COMPILER}    
Unsupported compiler!
{$ENDIF}



{$IFDEF J_CPPB_3}  // only required for C++Builder v3
{$ObjExportAll On }
{$ENDIF           }

