unit TestForms;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, XUtils, XXmlDom, StdCtrls;

type
  TTestForm = class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  TestForm: TTestForm;

implementation

{$R *.dfm}

procedure TTestForm.Button1Click(Sender: TObject);
var
	aDoc: TXmlDDocument;
	anElem2: TXmlDNode;
begin
	RO_Init(aDoc, TXmlDDocument.Create);
	try
		aDoc.Load(ExtractFilePath(ParamStr(0)) + '\Test.xml');
		Memo1.Lines.Text := aDoc.Xml;
		Memo1.Lines.Add('------------------------');
		anElem2 := aDoc.DocumentElement.SelectSingleNode('elem2');
		Memo1.Lines.Add(anElem2.Xml);
		Memo1.Lines.Add('------------------------');
		Memo1.Lines.Add((anElem2 as TXmlDElement).GetAttr('a2'));
	finally
		RO_Free(aDoc)
	end;
end;

end.
