unit UFrmAfTableInfoDemo;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Db, DBTables, AFTableInfo, StdCtrls, ExtCtrls, Grids, DBGrids, DBCtrls,
  Buttons;

type
  TForm1 = class(TForm)
    AFTableInfo1: TAFTableInfo;
    Table1: TTable;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    lbDbName: TLabel;
    Label2: TLabel;
    lbDir: TLabel;
    Label3: TLabel;
    lbName: TLabel;
    Label4: TLabel;
    lbType: TLabel;
    Label5: TLabel;
    lbIndex: TLabel;
    Label6: TLabel;
    lbState: TLabel;
    Label7: TLabel;
    lbRecordCount: TLabel;
    Label8: TLabel;
    lbRecNo: TLabel;
    Label9: TLabel;
    lbFilter: TLabel;
    Label10: TLabel;
    lbFiltered: TLabel;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    Panel1: TPanel;
    Button1: TButton;
    rgFiltered: TRadioGroup;
    rgUpdate: TRadioGroup;
    btUpdate: TButton;
    edFilter: TEdit;
    Label11: TLabel;
    Button2: TButton;
    DBNavigator1: TDBNavigator;
    cbIndex: TComboBox;
    Label12: TLabel;
    Panel2: TPanel;
    SpeedButton1: TSpeedButton;
    Label13: TLabel;
    lbReadOnly: TLabel;
    rgReadOnly: TRadioGroup;
    AFTableInfo2: TAFTableInfo;
    lbreadonlycaptions: TLabel;
    lbfilteredcaptions: TLabel;
    lbStateCaptions: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure rgFilteredClick(Sender: TObject);
    procedure rgUpdateClick(Sender: TObject);
    procedure btUpdateClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure cbIndexChange(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure rgReadOnlyClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
begin
If Table1.Active then
   begin
      Table1.Close;
      Button1.Caption := 'Open Table';
   end else begin
      Table1.Open;
      Button1.Caption := 'Close Table';
	end;
	rgReadOnly.Enabled := Table1.Active = False;
end;

procedure TForm1.rgFilteredClick(Sender: TObject);
const
	IsFiltered : Array[0..1] of Boolean = (True,False);
begin
	Table1.Filtered := IsFiltered[rgFiltered.ItemIndex];
end;

procedure TForm1.rgUpdateClick(Sender: TObject);
const
	AutoUpdated : Array[0..1] of Boolean = (True,False);
begin
	AfTableInfo1.AutoUpdate := AutoUpdated[rgUpdate.ItemIndex];
	AfTableInfo2.AutoUpdate := AfTableInfo1.AutoUpdate;
	btUpdate.Enabled := AfTableInfo1.AutoUpdate = False;
end;

procedure TForm1.btUpdateClick(Sender: TObject);
begin
	AfTableInfo1.Update;
	AfTableInfo2.Update;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
Table1.Filter := edfilter.Text;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
i: Integer;
begin
Table1.IndexDefs.Update;
for I := 0 to Table1.IndexDefs.Count - 1 do
	If Table1.IndexDefs.Items[I].Name = '' then
		cbIndex.Items.Add('(none)')
	else
		cbIndex.Items.Add(Table1.IndexDefs.Items[I].Name);
cbIndex.ItemIndex := 0;
btUpdateClick(self);
end;

procedure TForm1.cbIndexChange(Sender: TObject);
begin
with Table1 do
	If cbIndex.Items[cbindex.ItemIndex] = '(none)' then
		Table1.IndexName := ''
	else
		Table1.IndexName := cbIndex.Items[cbindex.ItemIndex];
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
If Table1.Active Then Table1.Close;
Close;
end;

procedure TForm1.rgReadOnlyClick(Sender: TObject);
const
	IsReadOnly : Array[0..1] of Boolean = (True,False);
begin
	Table1.ReadOnly := IsReadOnly[rgReadOnly.ItemIndex];
end;



end.
