unit Unit1;

interface

uses
  SysUtils, Classes, Forms,
  Controls, StdCtrls, ExtCtrls, DirectPort;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Edit1: TEdit;
    Memo1: TMemo;
    Timer1: TTimer;
    Edit2: TEdit;
    Button3: TButton;
    Button4: TButton;
    Port: TDirectPort;
    Label1: TLabel;
    Label2: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure SetFreq(f:Word);
var D:Integer;
begin
 D:=1193180 div f;
 Form1.Port.Byte[$43]:=$B6;
 Form1.POrt.Byte[$42]:=Lo(D);
 Form1.Port.Byte[$42]:=Hi(D);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  Port.Byte[$61]:=Port.Byte[$61] or $03;  // enable speaker
  setfreq(StrToInt(Edit1.Text));
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  Port.Byte[$61]:=Port.Byte[$61] and ($FF-$03);  // disable speaker
  setfreq(StrToInt(Edit1.Text));
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
 Memo1.Lines.Add(IntToHex(Port.Byte[StrToInt(Edit2.Text)],2));
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
 Timer1.Enabled:=True;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
 Timer1.Enabled:=False;
end;

end.
