unit UnitDll1;

interface

uses
  SysUtils, Classes, Forms,
  Controls, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Edit1: TEdit;
    Memo1: TMemo;
    Timer1: TTimer;
    Edit2: TEdit;
    Button3: TButton;
    Button4: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

const
 DPort32='Dport32.dll';

procedure InitDll; stdcall; external Dport32 index 7;
procedure DoneDll; stdcall; external Dport32 index 8;
procedure ReadPortByte(Port:Word;var ByteResult:Byte); stdcall; external Dport32 index 1;
procedure ReadPortWord(Port:Word;var WordResult:Word); stdcall; external Dport32 index 2;
procedure ReadPortDWord(Port:Word;var DWordResult:LongWord); stdcall; external Dport32 index 3;
procedure WritePortByte(Port:Word;ByteValue:Byte); stdcall; external Dport32 index 4;
procedure WritePortWord(Port:Word;WordValue:Word); stdcall; external Dport32 index 5;
procedure WritePortDWord(Port:Word;DWordValue:LongWord); stdcall; external Dport32 index 6;

procedure SetFreq(f:Word);
var D:Integer;
begin
 D:=1193180 div f;
 WritePortByte($43,$B6);
 WritePortByte($42,Lo(D));
 WritePortByte($42,Hi(D));
end;

procedure TForm1.Button1Click(Sender: TObject);
var B:Byte;
begin
  ReadPortByte($61,B);
  WritePortByte($61,B or $03);  //enable speaker
  setfreq(StrToInt(Edit1.Text));
end;

procedure TForm1.Button2Click(Sender: TObject);
var B:Byte;
begin
  ReadPortByte($61,B);
  WritePortByte($61,B and ($FF-$03));   // disable speaker
  setfreq(StrToInt(Edit1.Text));
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var B:Byte;
begin
 ReadPortByte(StrToInt(Edit2.Text),B);
 Memo1.Lines.Add(IntToHex(B,2));
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
 Timer1.Enabled:=True;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
 Timer1.Enabled:=False;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 InitDll;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
 DoneDll;
end;

end.
