unit Unit1;
interface
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, AviCap, AviCapH, Clipbrd, Menus;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Panel1: TPanel;
    Image1: TImage;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    Button8: TButton;
    Button9: TButton;
    Edit1: TEdit;
    Bevel1: TBevel;
    AviCap1: TAviCap;
    Button10: TButton;
    PopupMenu1: TPopupMenu;
    Item11: TMenuItem;
    Item21: TMenuItem;
    Item31: TMenuItem;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure AviCap1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure AviCap1MouseDown(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Button10Click(Sender: TObject);
  private
     { Private-Deklarationen }
  public
   {Public-Deklarationen }
  end;
var
  Form1: TForm1;

implementation
{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
begin
  with AviCap1 do
  begin
    if cap_Connected then
    begin
      cap_Connected := False;
      Button1.Caption := 'Connect';
    end
    else
    begin cap_Connected := True;
      Button1.Caption := 'Disconnect';
    end;
    Panel1.Visible := cap_Connected;
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  AviCap1.cap_DlgVideoCompression := true;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  AviCap1.cap_DlgVideoDisplay := true;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  AviCap1.cap_DlgVideoSourece := true;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  AviCap1.cap_DlgVideoFormat := true;

end;

procedure TForm1.Button6Click(Sender: TObject);
begin
  if messagedlg('Hit <OK> to start capture', mtConfirmation, [mbOK, mbAbort], 0) = mrOk then
  begin
    capPreview(avicap1.cap_WndHandle, 1);
    AviCap1.StartCapture;
  end
end;

procedure TForm1.Button7Click(Sender: TObject);
begin
  capGrabFrameNoStop(AviCap1.cap_WndHandle);
  capFileSaveDIB(AviCap1.cap_WndHandle, lparam(PChar(Edit1.Text)));
end;

procedure TForm1.Button8Click(Sender: TObject);
begin
  capGrabFrameNoStop(AviCap1.cap_WndHandle);
  capEditCopy(AviCap1.cap_WndHandle);
end;

procedure TForm1.Button9Click(Sender: TObject);
begin
  Button8Click(Sender);
  image1.Picture.Bitmap.LoadFromClipBoardFormat(cf_BitMap, ClipBoard.GetAsHandle(cf_Bitmap), 0);
  ClipBoard.Clear;
end;

procedure TForm1.AviCap1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  caption := 'Position X: ' + IntToSTr(x) + ';  Position Y: ' + INtToSTr(y);
end;

procedure TForm1.AviCap1MouseDown(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var
  r: Trect;
begin
  if ssLeft in Shift then
    beep;
  if ssRight in Shift then
  begin
    r := ClientRect;
    PopupMenu1.Popup(left + width - r.Right + x, top + height - r.Bottom + y);
  end;
end;

procedure TForm1.Button10Click(Sender: TObject);
begin
With AViCAp1 do
showblackscreen:= not showblackscreen
end;

end.

